#!/usr/local/bin/python2.2

import sys
import shot
from parc import ip, tui

def comp(render, name):
    ip.match_viewport(render)
    foreground = ip.image(render)
    background = ip.gradient((0.5, 0.5, 0.9, 1, 1), (0.5, 0.5, 0.9, 1, 1),
                             (0.2, 0.2, 0.6, 1, 1), (0.2, 0.2, 0.6, 1, 1))
    comp = ip.matte(foreground, background).get_image()
# Unix    
#   ft = ip.Font("/usr/share/fonts/default/Type1/n019003l.pfb")
# Windows
    ft = ip.Font("C:/WINNT/Fonts/arial.ttf")
    ft.set_size(16)
    ft.draw_string(comp, 19, 9,  name, 0, 0, 0)
    ft.draw_string(comp, 21, 9,  name, 0, 0, 0)
    ft.draw_string(comp, 19, 11, name, 0, 0, 0)
    ft.draw_string(comp, 21, 11, name, 0, 0, 0)
    ft.draw_string(comp, 20, 10, name, 0.8, 0.8, 0.8)
    return comp

def frame(scene):
    scene.set_format("1.85")
    scene.scale_viewport(6)
    scene.set_samples(2)
    scene.set_filter("gaussian", 2)
    scene.filename_directory = 'pics'
    scene.filename_prefix = 'f'
    shot.generate(scene)
    if scene.render() != 0:
        return None
    name = '%s  %03i' % (scene.filename_prefix, scene.frame)
    final = comp(scene.get_image(), name)
    final.write(scene.get_filename())
    return final

def run(min, max):
    imv = tui.ImageViewer()
    for i in range(min, max+1):
        print 'Computing frame: ', i
        scene = shot.Scene()
        scene.frame = i
        image = scene.get_image()
        imv.set_frame(image, i)
        final = frame(scene)
        if final == None:
            print 'Render interrupted.'
            break
        imv.set_frame(final, i)
#        scene.statistics()
    imv.wait_for_exit()
    
if __name__ == "__main__":
    argc = len(sys.argv)
    print '%i arguments' % argc
    if argc == 1:
        run(0, 0)
    elif argc == 2:
        frame = long(sys.argv[1])
        run(frame, frame)
    elif argc == 3:
        run(long(sys.argv[1]), long(sys.argv[2]))
    else:
        print 'Usage: run [single_frame | min_frame max_frame]'
    
