#! /usr/bin/env python

from common import *

def generate_geometry(view):
    plane = Plane()
    plane.l2w = matrix.Matrix()
    plane.l2w.set_scale(3, 3, 3)
    plane.l2w.rotate(-90, 0, 0)
    material = Diffuse(0.5, 0.9, 0.5, 0.5)
    view.add_geometry(plane, material, 3)

    material = Diffuse(0.5, 0.2, 0.3)
    map = ImageMap("texture.ppm")
    material.Kd = map
    cube = Cube()
    cube.l2w = matrix.Matrix()
    cube.l2w.set_translate(0, 1, 5)
    cube.l2w.lookat(5,3,7)
    view.add_geometry(cube, material, 3)
    
run(generate_geometry, "Transparency")

